/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.66 by edhill, Mon Feb 23 21:51:32 2004 UTC revision 1.150 by edhill, Mon May 22 22:11:11 2006 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 37  test_for_string_in_file() { Line 45  test_for_string_in_file() {
45      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
46      RETVAL=$?      RETVAL=$?
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 67  expand_pkg_groups() { Line 75  expand_pkg_groups() {
75          done          done
76          PACKAGES=$new_packages          PACKAGES=$new_packages
77          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
78            return $matched
79      else      else
80          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81      fi      fi
82  }  }
83    
84    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86    check_for_broken_Ff()  {
87        #  Do we have defaults for $FS and/or $FS90 ?
88        tfs=f
89        tfs9=f90
90        if test "x$FS" != x ; then
91            tfs="$FS"
92        fi
93        if test "x$FS90" != x ; then
94            tfs9="$FS90"
95        fi
96    
97        #  First check the ability to create a *.F/.f pair.
98        cat <<EOF >> genmake_hello.F
99          program hello
100          write(*,*) 'hi'
101          stop
102          end
103    EOF
104        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105        RETVAL=$?
106        if test "x$RETVAL" != x0 ; then
107            if test "x$FS" = x ; then
108                FS='for'
109                FS90='fr9'
110                check_for_broken_Ff
111            else
112                cat <<EOF 2>&1
113    ERROR: Your file system cannot distinguish between *.F and *.f files
114      (fails the "cp" test) and this program cannot find a suitable
115      replacement extension.  Please try a different build environment or
116      contact the <MITgcm-support@mitgcm.org> list for help.
117    
118    EOF
119                exit -1
120            fi
121            return
122        fi
123        rm -f genmake_hello.*
124    
125        #  Check the ability of ${MAKE} and ${LN} to use the current set
126        #  of extensions.
127        cat <<EOF >> genmake_hello.F
128          program hello
129          write(*,*) 'hi'
130          stop
131          end
132    EOF
133        test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134        cat <<EOF >> $MAKEFILE
135    .SUFFIXES:
136    .SUFFIXES: .$tfs .F
137    .F.$tfs:
138            $LN \$< \$@
139    EOF
140        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141        RETVAL=$?
142        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143            if test "x$FS" = x ; then
144                FS='for'
145                FS90='fr9'
146                check_for_broken_Ff
147            else
148                cat <<EOF 2>&1
149    ERROR: Your file system cannot distinguish between *.F and *.f files
150      (fails the "make/ln" test) and this program cannot find a suitable
151      replacement extension.  Please try a different build environment or
152      contact the <MITgcm-support@mitgcm.org> list for help.
153    
154    EOF
155                exit -1
156                return
157            fi
158        fi
159        rm -f genmake_hello.* $MAKEFILE
160        test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162        #  If we make it here, use the extensions
163        FS=$tfs
164        FS90=$tfs9
165        return
166    }
167    
168    
169    look_for_makedepend()  {
170    
171        #  The "original" makedepend is part of the Imake system that is
172        #  most often distributed with XFree86 or with an XFree86 source
173        #  package.  As a result, many machines (eg. generic Linux) do not
174        #  have a system-default "makedepend" available.  For those
175        #  systems, we have two fall-back options:
176        #
177        #    1) a makedepend implementation shipped with the cyrus-imapd
178        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179        #
180        #    2) a known-buggy xmakedpend shell script
181        #
182        #  So the choices are, in order:
183        #
184        #    1) use the user-specified program
185        #    2) use a system-wide default
186        #    3) locally build and use the cyrus implementation
187        #    4) fall back to the buggy local xmakedpend script
188        #
189        if test "x${MAKEDEPEND}" = x ; then
190            which makedepend > /dev/null 2>&1
191            RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201            cat <<EOF >> genmake_tc.f
202          program test
203          write(*,*) 'test'
204          stop
205          end
206    EOF
207            makedepend genmake_tc.f > /dev/null 2>&1
208            RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211            if test "x${RV0}${RV1}" = x00 ; then
212                MAKEDEPEND=makedepend
213            else
214                echo "    a system-default makedepend was not found."
215                
216                #  Try to build the cyrus implementation
217                build_cyrus_makedepend
218                RETVAL=$?
219                if test "x$RETVAL" != x0 ; then
220                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221                fi
222                rm -f ./genmake_cy_md
223            fi
224        else
225            #  echo "MAKEDEPEND=${MAKEDEPEND}"
226            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227            RETVAL=$?
228            if test x"$RETVAL" = x0 ; then
229                build_cyrus_makedepend
230            fi
231        fi
232    }
233    
234    
235    build_cyrus_makedepend()  {
236        rm -f ./genmake_cy_md
237        (
238            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
239                &&  ./configure > /dev/null 2>&1  \
240                &&  make > /dev/null 2>&1
241            if test -x ./makedepend.exe ; then
242                $LN ./makedepend.exe ./makedepend
243            fi
244            ./makedepend ifparser.c > /dev/null 2>&1  \
245                &&  echo "true"
246        ) > ./genmake_cy_md
247        grep true ./genmake_cy_md > /dev/null 2>&1
248        RETVAL=$?
249        rm -f ./genmake_cy_md
250        if test "x$RETVAL" = x0 ; then
251            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252            return 0
253        else
254            echo "WARNING: unable to build cyrus-imapd-makedepend"
255            return 1
256        fi
257    }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 80  find_possible_configs()  { Line 299  find_possible_configs()  {
299      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303        PLATFORM=$tmp3
304        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
305      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
307            
# Line 100  find_possible_configs()  { Line 321  find_possible_configs()  {
321          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
322      fi      fi
323    
324      # makedepend is not always available      look_for_makedepend
325      if test "x${MAKEDEPEND}" = x ; then  
326        which makedepend >& /dev/null      #================================================================
327        RETVAL=$?      #  look for possible C compilers
328        if test "x${RETVAL}" = x1 ; then      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
329           echo "    makedepend was not found. Using xmakedpend instead."      p_CC=
330           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'      for c in $tmp ; do
331        fi          rm -f ./genmake_hello.c  ./genmake_hello
332            cat >> genmake_hello.c << EOF
333    #include <stdio.h>
334    int main(int argc, char **argv) {
335      printf("Hello!\n");
336      return 0;
337    }
338    EOF
339            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340            RETVAL=$?
341            if test "x${RETVAL}" = x0 ; then
342                p_CC="$p_CC $c"
343            fi
344        done
345        rm -f ./genmake_hello.c ./genmake_hello
346        if test "x${p_CC}" = x ; then
347            cat 1>&2 <<EOF
348    
349    Error: No C compilers were found in your path.  Please specify one using:
350    
351        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352        2) the CC or MITGCM_CC environment variables.
353    
354    EOF
355            exit 1
356        else
357            echo "  The possible C compilers found in your path are:"
358            echo "   "$p_CC
359            if test "x$CC" = x ; then
360                CC=`echo $p_CC | $AWK '{print $1}'`
361                echo "  Setting C compiler to: "$CC
362            fi
363      fi      fi
364    
365      # look for possible fortran compilers      #================================================================
366      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      #  look for possible FORTRAN compilers
367        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 136  Error: No Fortran compilers were found i Line 389  Error: No Fortran compilers were found i
389    
390      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
392      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
393    
394  EOF  EOF
395          exit 1          exit 1
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
         if test "x$FC" = x ; then  
             FC=`echo $p_FC | $AWK '{print $1}'`  
         fi  
399      fi      fi
400    
401      for i in $p_FC ; do      #  Use the first of the compilers found in the current PATH
402          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i      #  that has a correctly-named optfile
403          if test -r $p_OF ; then      if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404              OPTFILE=$p_OF          for i in $p_FC ; do
405              echo "  The options file:  $p_OF"              OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406              echo "    appears to match so we'll use it."              if test -r $OPTFILE ; then
407              break                  echo "  Setting OPTFILE to: "$OPTFILE
408          fi                  break
409      done              fi
410            done
411        fi
412    
413        if test "x$OPTFILE" = x ; then
414            OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415            if test ! -r $OPTFILE ; then
416                 echo "  I looked for the file "$OPTFILE" but did not find it"
417            fi
418        fi
419    #    echo "  The options file:  $p_OF"
420    #    echo "    appears to match so we'll use it."
421    #   for i in $p_FC ; do
422    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423    #if test -r $p_OF ; then
424    #    OPTFILE=$p_OF
425    #    echo "  The options file:  $p_OF"
426    #    echo "    appears to match so we'll use it."
427    #    break
428    #fi
429    #   done
430      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
431          cat 1>&2 <<EOF          cat 1>&2 <<EOF
432    
# Line 215  get_pdepend_list()  { Line 485  get_pdepend_list()  {
485      . ./.pd_tmp      . ./.pd_tmp
486      rm -f ./.pd_tmp      rm -f ./.pd_tmp
487    
488      echo -n "PNAME = "${}      printf "PNAME = "${}
489  }  }
490    
491    
# Line 229  Usage: "$0" [OPTIONS] Line 499  Usage: "$0" [OPTIONS]
499      -help | --help | -h | --h      -help | --help | -h | --h
500            Print this help message and exit.            Print this help message and exit.
501    
502        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504              Use "NAME" as the adoptfile.  By default, the file at
505              "tools/adjoint_options/adjoint_default" will be used.
506    
507      -nooptfile | --nooptfile      -nooptfile | --nooptfile
508        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
509        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 253  Usage: "$0" [OPTIONS] Line 528  Usage: "$0" [OPTIONS]
528        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
529            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
530    
531        -makedepend NAME | -md NAME
532          --makedepend=NAME | -md=NAME
533              Use "NAME" for the MAKEDEPEND program.
534    
535      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 289  Usage: "$0" [OPTIONS] Line 568  Usage: "$0" [OPTIONS]
568            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
569            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
570    
571        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572              Use "NAME" as the C compiler.  By default, genmake
573              will search for a working compiler by trying a list of
574              "usual suspects" such as gcc, c89, cc, etc.
575    
576      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
577            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604    
605        -mpi | --mpi
606              Include MPI header files and link to MPI libraries
607        -mpi=PATH | --mpi=PATH
608              Include MPI header files and link to MPI libraries using MPI_ROOT
609              set to PATH. i.e. Include files from \$PATH/include, link to libraries
610              from \$PATH/lib and use binaries from \$PATH/bin.
611    
612        -es | --es | -embed-source | --embed-source
613              Embed a tarball containing the full source code
614              (including the Makefile, etc.) used to build the
615              executable [off by default]
616    
617        -bash NAME
618              Explicitly specify the Bourne or BASH shell to use
619    
620    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
621    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
622    
# Line 314  EOF Line 637  EOF
637    
638  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
639  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
640    
641        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
642        if test ! "x$FC_NAMEMANGLE" = x ; then
643            return 0
644        fi
645    
646      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
647            
648      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 331  WARNING: Please contact <MITgcm-support@ Line 660  WARNING: Please contact <MITgcm-support@
660  EOF  EOF
661          return 1          return 1
662      fi      fi
663      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
664      RETVAL=$?      RETVAL=$?
665      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
666          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 343  WARNING: Please contact <MITgcm-support@ Line 672  WARNING: Please contact <MITgcm-support@
672  EOF  EOF
673          return 1          return 1
674      fi      fi
675      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
676        subroutine tcall( string )        subroutine tcall( string )
677        character*(*) string        character*(*) string
678        call tsub( string )        call tsub( string )
679        end        end
680  EOF  EOF
681      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
682      RETVAL=$?      RETVAL=$?
683      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
684          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 361  WARNING: Please contact <MITgcm-support@ Line 690  WARNING: Please contact <MITgcm-support@
690  EOF  EOF
691          return 1          return 1
692      fi      fi
693      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
694      RETVAL=$?      RETVAL=$?
695      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
696          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 415  void FC_NAMEMANGLE(cloc) ( double *curti Line 744  void FC_NAMEMANGLE(cloc) ( double *curti
744   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
745  }  }
746  EOF  EOF
747      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
748      RET_C=$?      RET_C=$?
749      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
750        program hello        program hello
751        Real*8 wtime        REAL*8 wtime
752        external cloc        external cloc
753        call cloc(wtime)        call cloc(wtime)
754        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
755        end program hello        end
756  EOF  EOF
757      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
758      RET_F=$?      RET_F=$?
759      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
760      RETVAL=$?      RETVAL=$?
761      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
762          HAVE_CLOC=t          HAVE_CLOC=t
# Line 437  EOF Line 766  EOF
766  }  }
767    
768    
769    check_HAVE_SIGREG()  {
770        if test ! "x$HAVE_SIGREG" = x ; then
771            return
772        fi
773        get_fortran_c_namemangling
774        cat <<EOF > genmake_tc_1.c
775    $FC_NAMEMANGLE
776    #include <stdlib.h>
777    #include <stdio.h>
778    #include <signal.h>
779    #include <errno.h>
780    #include <ucontext.h>
781    
782    int * ip;
783    
784    static void killhandler(
785        unsigned int sn, siginfo_t  si, struct ucontext *sc )
786    {
787        *ip = *ip + 1;
788        return;
789    }
790    
791    void FC_NAMEMANGLE(sigreg) (int * aip)
792    {
793        struct sigaction s;
794        ip = aip;
795        s.sa_flags = SA_SIGINFO;
796        s.sa_sigaction = (void *)killhandler;
797        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
798            printf("Sigaction returned error = %d\n", errno);
799            exit(0);
800        }
801        return;
802    }
803    EOF
804        make genmake_tc_1.o >> genmake_warnings 2>&1
805        RET_C=$?
806        cat <<EOF > genmake_tc_2.$FS
807          program hello
808          integer anint
809          common /iv/ anint
810          external sigreg
811          call sigreg(anint)
812          end
813    EOF
814        echo >> genmake_warnings
815        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
816        cat genmake_tc_2.$FS >> genmake_warnings
817        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
818        echo $COMM >> genmake_warnings
819        $COMM >> genmake_warnings 2>&1
820        RETVAL=$?
821        if test "x$RETVAL" = x0 ; then
822            HAVE_SIGREG=t
823            DEFINES="$DEFINES -DHAVE_SIGREG"
824        fi
825        rm -f genmake_tc*
826    }
827    
828    
829    check_HAVE_SETRLSTK()  {
830        get_fortran_c_namemangling
831        cat <<EOF > genmake_tc_1.c
832    $FC_NAMEMANGLE
833    #include <sys/time.h>
834    #include <sys/resource.h>
835    #include <unistd.h>
836    void FC_NAMEMANGLE(setrlstk) ()
837    {
838        struct rlimit rls;
839        rls.rlim_cur = RLIM_INFINITY;
840        rls.rlim_max = RLIM_INFINITY;
841        setrlimit(RLIMIT_STACK, &rls);
842        return;
843    }
844    EOF
845        make genmake_tc_1.o >> genmake_warnings 2>&1
846        RET_C=$?
847        cat <<EOF > genmake_tc_2.$FS
848          program hello
849          external setrlstk
850          call setrlstk()
851          end
852    EOF
853        echo >> genmake_warnings
854        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
855        cat genmake_tc_2.$FS >> genmake_warnings
856        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
857        echo $COMM >> genmake_warnings
858        $COMM >> genmake_warnings 2>&1
859        RETVAL=$?
860        if test "x$RETVAL" = x0 ; then
861            HAVE_SETRLSTK=t
862            DEFINES="$DEFINES -DHAVE_SETRLSTK"
863        fi
864        rm -f genmake_tc*
865    }
866    
867    
868    check_HAVE_STAT()  {
869        get_fortran_c_namemangling
870        cat <<EOF > genmake_tc_1.c
871    $FC_NAMEMANGLE
872    #include <stdio.h>
873    #include <stdlib.h>
874    #include <unistd.h>
875    #include <sys/stat.h>
876    #include <sys/types.h>
877    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
878    {
879        char name[512];
880        struct stat astat;
881    
882        name[0] = 'a'; name[1] = '\0';
883        if (! stat(name, &astat))
884            *nbyte = (int)(astat.st_size);
885        else
886            *nbyte = -1;
887    }
888    EOF
889        make genmake_tc_1.o >> genmake_tc.log 2>&1
890        RET_C=$?
891        cat <<EOF > genmake_tc_2.$FS
892          program hello
893          integer nbyte
894          call tfsize(nbyte)
895          print *," HELLO WORLD", nbyte
896          end
897    EOF
898        echo >> genmake_warnings
899        echo "running: check_HAVE_STAT()" >> genmake_warnings
900        cat genmake_tc_2.$FS >> genmake_warnings
901        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
902        echo $COMM >> genmake_warnings
903        $COMM >> genmake_tc.log 2>&1
904        RETVAL=$?
905        if test "x$RETVAL" = x0 ; then
906            HAVE_STAT=t
907            DEFINES="$DEFINES -DHAVE_STAT"
908        fi
909        rm -f genmake_tc*
910    }
911    
912    
913  check_netcdf_libs()  {  check_netcdf_libs()  {
914        if test ! "x$SKIP_NETCDF_CHECK" = x ; then
915            return
916        fi
917        echo >> genmake_warnings
918        echo "running: check_netcdf_libs()" >> genmake_warnings
919      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
920        program fgennc        program fgennc
921  #include "netcdf.inc"  #include "netcdf.inc"
922    EOF
923        if test ! "x$MPI" = x ; then
924            echo '#include "mpif.h"' >> genmake_tnc.F
925        fi
926        cat <<EOF >> genmake_tnc.F
927        integer iret, ncid, xid        integer iret, ncid, xid
928        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
929        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 450  check_netcdf_libs()  { Line 933  check_netcdf_libs()  {
933        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
934        end        end
935  EOF  EOF
936      $CPP genmake_tnc.F > genmake_tnc.f  \      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
937          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      cat genmake_tnc.F >> genmake_tnc.log
938        echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
939        RET_CPP=f
940        COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
941        echo "$COMM" >> genmake_tnc.log
942        $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
943        if test "x$RET_CPP" = xf ; then
944            echo "  WARNING: CPP failed to pre-process the netcdf test." \
945                >> genmake_tnc.log
946            echo "    Please check that \$INCLUDES is properly set." \
947                >> genmake_tnc.log
948        fi
949        echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
950        echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log
951        $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
952            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
953      RET_COMPILE=$?      RET_COMPILE=$?
954      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      cat genmake_tnc.log >> genmake_warnings
955      RETVAL=$?  
956      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      #EH3  Remove test program execution for machines that either disallow
957        #EH3  execution or cannot support it (eg. cross-compilers)
958        #EH3
959        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
960        #EH3 RETVAL=$?
961        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
962    
963        if test "x$RET_COMPILE" = x0 ; then
964          HAVE_NETCDF=t          HAVE_NETCDF=t
965      else      else
966          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
967          $CPP genmake_tnc.F > genmake_tnc.f  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
968              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
969              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
970            echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
971            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
972                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
973                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
974          RET_COMPILE=$?          RET_COMPILE=$?
975          test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1          cat genmake_tnc.log >> genmake_warnings
976          RETVAL=$?          if test "x$RET_COMPILE" = x0 ; then
         if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then  
977              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
978              HAVE_NETCDF=t              HAVE_NETCDF=t
         else  
             cat genmake_tnc.log >> genmake_warnings  
979          fi          fi
980      fi      fi
981      rm -f genmake_tnc*      rm -f genmake_tnc*
982  }  }
983    
984    
985    
986    ###############################################################################
987    #   Sequential part of script starts here
988    ###############################################################################
989    
990  #  Set defaults here  #  Set defaults here
991  COMMANDL="$0 $@"  COMMANDL="$0 $@"
992    
# Line 483  PLATFORM= Line 994  PLATFORM=
994  LN=  LN=
995  S64=  S64=
996  KPP=  KPP=
997  FC=  #FC=
998  CPP=  #CC=gcc
999    #CPP=
1000  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
1001  DEFINES=  DEFINES=
1002  PACKAGES=  PACKAGES=
1003  ENABLE=  ENABLE=
1004  DISABLE=  DISABLE=
1005  MAKEFILE=  # MAKEFILE=
1006  MAKEDEPEND=  # MAKEDEPEND=
1007  PDEPEND=  PDEPEND=
1008  DUMPSTATE=t  DUMPSTATE=t
1009  PDEFAULT=  PDEFAULT=
1010  OPTFILE=  OPTFILE=
1011  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
1012  FFLAGS=  FFLAGS=
1013  FOPTIM=  FOPTIM=
1014  CFLAGS=  CFLAGS=
1015  KFLAGS1=  KFLAGS1=
1016  KFLAGS2=  KFLAGS2=
1017    #LDADD=
1018  LIBS=  LIBS=
1019  KPPFILES=  KPPFILES=
1020  NOOPTFILES=  NOOPTFILES=
1021  NOOPTFLAGS=  NOOPTFLAGS=
1022    MPI=
1023    MPIPATH=
1024    TS=
1025    PAPIS=
1026    PCLS=
1027    FOOLAD=
1028    PAPI=
1029    PCL=
1030    HPMT=
1031    GSL=
1032    HAVE_TEST_L=
1033    
1034  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1035  HAVE_SYSTEM=  HAVE_SYSTEM=
1036  HAVE_FDATE=  HAVE_FDATE=
1037  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1038  HAVE_CLOC=  HAVE_CLOC=
1039    HAVE_SETRLSTK=
1040    HAVE_STAT=
1041  HAVE_NETCDF=  HAVE_NETCDF=
1042    HAVE_ETIME=
1043    IGNORE_TIME=
1044    
1045  MODS=  MODS=
1046  TOOLSDIR=  TOOLSDIR=
# Line 521  SOURCEDIRS= Line 1048  SOURCEDIRS=
1048  INCLUDEDIRS=  INCLUDEDIRS=
1049  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
1050    
1051    G2ARGS=
1052    BASH=
1053  PWD=`pwd`  PWD=`pwd`
1054  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1055  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1056  THISHOSTNAME=`hostname`  EMBED_SRC=
1057    THISHOST=`hostname`
1058  THISCWD=`pwd`  THISCWD=`pwd`
1059  THISDATE=`date`  THISDATE=`date`
1060    THISUSER=`echo $USER`
1061    THISVER=
1062  MACHINE=`uname -a`  MACHINE=`uname -a`
1063  EXECUTABLE=  EXECUTABLE=
1064  EXEHOOK=  EXEHOOK=
# Line 536  IEEE= Line 1068  IEEE=
1068  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
1069      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
1070  fi  fi
1071    FS=
1072    FS90=
1073    
1074  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
1075  AD_OPTFILE=  AD_OPTFILE=
# Line 553  TAMC_EXTRA= Line 1087  TAMC_EXTRA=
1087    
1088  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1089  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1090  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"
1091    
1092  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1093  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
1094  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1095  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1096  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1097  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1098    
1099  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
1100  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 589  for i in . $MODS ; do Line 1123  for i in . $MODS ; do
1123          break          break
1124      fi      fi
1125  done  done
1126  echo -n "  getting local config information:  "  printf "  getting local config information:  "
1127  if test -e $gm_local ; then  if test -f $gm_local ; then
1128      echo "using $gm_local"      echo "using $gm_local"
1129      . $gm_local      . $gm_local
1130      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 599  else Line 1133  else
1133      echo "none found"      echo "none found"
1134  fi  fi
1135    
1136  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1137  #OPTIONS=  #OPTIONS=
1138  #n=0  #n=0
1139  #for i ; do  #for i ; do
# Line 611  fi Line 1145  fi
1145  #done  #done
1146  #parse_options  #parse_options
1147  ac_prev=  ac_prev=
1148  for ac_option ; do  for ac_option in "$@" ; do
1149    
1150        G2ARGS="$G2ARGS \"$ac_option\""
1151    
1152      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
1153      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 654  for ac_option ; do Line 1190  for ac_option ; do
1190          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
1191              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
1192                    
1193            -bash | --bash)
1194                ac_prev=BASH ;;
1195            -bash=* | --bash=*)
1196                BASH=$ac_optarg ;;
1197            
1198            -makedepend | --makedepend | -md | --md)
1199                ac_prev=MAKEDEPEND ;;
1200            -makedepend=* | --makedepend=* | -md=* | --md=*)
1201                MAKEDEPEND=$ac_optarg ;;
1202            
1203          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
1204              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
1205          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 695  for ac_option ; do Line 1241  for ac_option ; do
1241  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1242  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1243  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1244                        
1245            -cc | --cc)
1246                ac_prev=CC ;;
1247            -cc=* | --cc=*)
1248                CC=$ac_optarg ;;
1249            
1250          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1251              ac_prev=FC ;;              ac_prev=FC ;;
1252          -fc=* | --fc=*)          -fc=* | --fc=*)
1253              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1254                    
1255            -fs | --fs)
1256                ac_prev=FS ;;
1257            -fs=* | --fs=*)
1258                FS=$ac_optarg ;;
1259            
1260            -fs90 | --fs90)
1261                ac_prev=FS90 ;;
1262            -fs90=* | --fs90=*)
1263                FS90=$ac_optarg ;;
1264            
1265          -ieee | --ieee)          -ieee | --ieee)
1266              IEEE=true ;;              IEEE=true ;;
1267          -noieee | --noieee)          -noieee | --noieee)
1268              IEEE= ;;              IEEE= ;;
1269    
1270            -ts | --ts)
1271                TS=true ;;
1272            -papis | --papis)
1273                PAPIS=true ;;
1274            -pcls | --pcls)
1275                PCLS=true ;;
1276            -foolad | --foolad)
1277                FOOLAD=true ;;
1278            -papi | --papi)
1279                PAPI=true ;;
1280            -pcl | --pcl)
1281                PCL=true ;;
1282            -hpmt | --hpmt)
1283                HPMT=true ;;
1284    
1285            -gsl | --gsl)
1286                GSL=true ;;
1287    
1288            -mpi | --mpi)
1289                MPI=true ;;
1290            -mpi=* | --mpi=*)
1291                MPIPATH=$ac_optarg
1292                MPI=true ;;
1293                    
1294  #       -jam | --jam)  #       -jam | --jam)
1295  #           JAM=1 ;;  #           JAM=1 ;;
# Line 723  for ac_option ; do Line 1308  for ac_option ; do
1308              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1309          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1310              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1311            
1312            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1313                IGNORE_TIME="-DIGNORE_TIME" ;;
1314    
1315            -es | --es | -embed-source | --embed-source)
1316                EMBED_SRC=t ;;
1317    
1318          -*)          -*)
1319              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 738  for ac_option ; do Line 1329  for ac_option ; do
1329            
1330  done  done
1331    
1332    
1333  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1334      echo      echo
1335      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
# Line 750  if test -f ./.genmakerc ; then Line 1342  if test -f ./.genmakerc ; then
1342      echo      echo
1343  fi  fi
1344    
1345    #  Find the MITgcm ${ROOTDIR}
1346  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1347      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1348        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1349          ROOTDIR=".."          ROOTDIR=".."
1350      else      else
1351          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1352              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1353                  ROOTDIR=$d                  ROOTDIR=$d
1354                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1355                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1356                  break                  break
1357              fi              fi
# Line 775  if test ! -d ${ROOTDIR} ; then Line 1369  if test ! -d ${ROOTDIR} ; then
1369      exit 1      exit 1
1370  fi  fi
1371    
1372    #  Find the MITgcm ${THISVER}
1373    if test -f "${ROOTDIR}/doc/tag-index" ; then
1374        THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1375    fi
1376    
1377    if test "x$MAKEFILE" = x ; then
1378        MAKEFILE="Makefile"
1379    fi
1380    
1381  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1382  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1383      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 791  if test "x$OPTFILE" != xNONE ; then Line 1394  if test "x$OPTFILE" != xNONE ; then
1394          . "$OPTFILE"          . "$OPTFILE"
1395          RETVAL=$?          RETVAL=$?
1396          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1397              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1398              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1399              exit 1              exit 1
1400          fi          fi
# Line 818  if test "x${AD_OPTFILE}" != xNONE ; then Line 1421  if test "x${AD_OPTFILE}" != xNONE ; then
1421          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1422          RETVAL=$?          RETVAL=$?
1423          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1424              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1425              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1426              exit 1              exit 1
1427          fi          fi
# Line 831  if test "x${AD_OPTFILE}" != xNONE ; then Line 1434  if test "x${AD_OPTFILE}" != xNONE ; then
1434      fi      fi
1435  fi  fi
1436    
1437  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #====================================================================
1438    #  Set default values if not set by the optfile
1439    #
1440    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1441  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1442    if test ! "x$BASH" = x ; then
1443        # add a trailing space so that it works within the Makefile syntax (see below)
1444        BASH="$BASH "
1445    fi
1446  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1447      cat <<EOF 1>&2      cat <<EOF 1>&2
1448    
# Line 843  Error: no Fortran compiler: please speci Line 1453  Error: no Fortran compiler: please speci
1453  EOF  EOF
1454      exit 1      exit 1
1455  fi  fi
1456    if test "x$CC" = x ; then
1457        CC=cc
1458    #     cat <<EOF 1>&2
1459    # Error: no C compiler: please specify using one of the following:
1460    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1461    #   2) the "-cc=XXX" command-line option
1462    #   3) the "./genmake_local" file
1463    # EOF
1464    #     exit 1
1465    fi
1466  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1467      LINK=$FC      LINK=$FC
1468  fi  fi
# Line 853  if test "x$CPP" = x ; then Line 1473  if test "x$CPP" = x ; then
1473      CPP=cpp      CPP=cpp
1474  fi  fi
1475  #EH3 === UGLY ===  #EH3 === UGLY ===
1476  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1477  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1478  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1479  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1480  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 877  EOF Line 1497  EOF
1497  else  else
1498      rm -f test_cpp      rm -f test_cpp
1499  fi  fi
1500  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1501  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1502      LN="ln -s"      LN="ln -s"
1503  fi  fi
# Line 895  Error: The command "ln -s" failed -- ple Line 1513  Error: The command "ln -s" failed -- ple
1513  EOF  EOF
1514      exit 1      exit 1
1515  fi  fi
1516    test -L genmake_tlink > /dev/null 2>&1
1517    RETVAL=$?
1518    if test "x$RETVAL" = x0 ; then
1519        HAVE_TEST_L=t
1520    fi
1521  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1522    
1523    #  Check for broken *.F/*.f handling and fix if possible
1524    check_for_broken_Ff
1525    
1526    if test ! "x$MPI" = x ; then
1527          echo "  Turning on MPI cpp macros"
1528          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1529    fi
1530    
1531    if test ! "x$TS" = x ; then
1532          echo "  Turning on timing per timestep"
1533          if test ! "x$FOOLAD" = x ; then
1534                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1535          else
1536                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1537          fi
1538    fi
1539    if test ! "x$PAPIS" = x ; then
1540          echo "  Turning on PAPI flop summary per timestep"
1541          echo "  Please make sure PAPIINC, PAPILIB are defined"
1542          if test ! "x$FOOLAD" = x ; then
1543                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1544          else
1545                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1546          fi
1547          INCLUDES="$INCLUDES $PAPIINC"
1548          LIBS="$LIBS $PAPILIB"
1549    fi
1550    if test ! "x$PCLS" = x ; then
1551          echo "  Turning on PCL counter summary per timestep"
1552          echo "  Please make sure PCLINC, PCLLIB are defined"
1553          if test ! "x$FOOLAD" = x ; then
1554                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1555          else
1556                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1557          fi
1558          INCLUDES="$INCLUDES $PCLINC"
1559          LIBS="$LIBS $PCLLIB"
1560    fi
1561    if test ! "x$PAPI" = x ; then
1562          if test ! "x$PAPIS" = x ; then
1563              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1564              echo "  Sticking with PAPI flop summary per timestep!"
1565          else
1566              echo "  Turning on performance analysis with PAPI"
1567              echo "  Please make sure PAPIINC, PAPILIB are defined"
1568              DEFINES="$DEFINES -DUSE_PAPI"
1569              INCLUDES="$INCLUDES $PAPIINC"
1570              LIBS="$LIBS $PAPILIB"
1571          fi
1572    fi
1573    if test ! "x$PCL" = x ; then
1574          if test ! "x$PCLS" = x ; then
1575              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1576              echo "  Sticking with PCL flop summary per timestep!"
1577          else
1578              echo "  Turning on performance analysis with PCL"
1579              echo "  Please make sure PCLINC, PCLLIB are defined"
1580              DEFINES="$DEFINES -DUSE_PCL"
1581              INCLUDES="$INCLUDES $PCLINC"
1582              LIBS="$LIBS $PCLLIB"
1583          fi
1584    fi
1585    if test ! "x$HPMT" = x ; then
1586          if test ! "x$PAPI" = x ; then
1587              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1588              echo "  Sticking with PAPI!"
1589          else if test ! "x$PCL" = x ; then
1590              echo "  PCL and the HPM Toolkit cannot co-exist!"
1591              echo "  Sticking with PCL!"
1592          else
1593              echo "  Turning on performance analysis with the HPM Toolkit"
1594              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1595              DEFINES="$DEFINES -DUSE_LIBHPM"
1596              INCLUDES="$INCLUDES $HPMTINC"
1597              LIBS="$LIBS $HPMTLIB"
1598          fi
1599          fi
1600    fi
1601    if test ! "x$GSL" = x ; then
1602          echo "  Turning on use of GSL to control floating point calculations"
1603          echo "  Please make sure GSLINC, GSLLIB are defined"
1604          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1605          INCLUDES="$INCLUDES $GSLINC"
1606          LIBS="$LIBS $GSLLIB"
1607    fi
1608    
1609  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1610  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1611  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1612        program hello        program hello
1613        call system('echo hi')        call system('echo hi')
1614        end        end
1615  EOF  EOF
1616  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1617  RETVAL=$?  RETVAL=$?
1618  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1619      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 917  else Line 1625  else
1625  fi  fi
1626  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1627    
1628  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1629  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1630        program hello        program hello
1631        CHARACTER(128) string        CHARACTER*(128) string
1632        string = ' '        string = ' '
1633        call fdate( string )        call fdate( string )
1634        print *, string        print *, string
1635        end        end
1636  EOF  EOF
1637  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1638  RETVAL=$?  RETVAL=$?
1639  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1640      HAVE_FDATE=t      HAVE_FDATE=t
# Line 938  else Line 1646  else
1646  fi  fi
1647  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1648    
1649  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1650    cat > genmake_tcomp.$FS <<EOF
1651          program hello
1652          REAL*4 ACTUAL, TARRAY(2)
1653          EXTERNAL ETIME
1654          REAL*4 ETIME
1655          actual = etime( tarray )
1656          print *, tarray
1657          end
1658    EOF
1659    $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1660    RETVAL=$?
1661    if test "x$RETVAL" = x0 ; then
1662        HAVE_ETIME=t
1663        DEFINES="$DEFINES -DHAVE_ETIME"
1664        echo "yes"
1665    else
1666        HAVE_ETIME=
1667        echo "no"
1668    fi
1669    rm -f genmake_tcomp*
1670    
1671    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1672  check_HAVE_CLOC  check_HAVE_CLOC
1673  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1674      echo "yes"      echo "yes"
1675  else  else
1676      echo "no"      echo "no"
1677        if test "x$EMBED_SRC" = xt ; then
1678            echo "    WARNING: you requested file embedding but it has"
1679            echo "      been disabled since C code cannot be called"
1680            EMBED_SRC=
1681        fi
1682    fi
1683    rm -f genmake_t*
1684    
1685    printf "  Can we unlimit the stack size using $FC...  "
1686    check_HAVE_SETRLSTK
1687    if test "x$HAVE_SETRLSTK" != x ; then
1688        echo "yes"
1689    else
1690        echo "no"
1691    fi
1692    rm -f genmake_t*
1693    
1694    printf "  Can we register a signal handler using $FC...  "
1695    check_HAVE_SIGREG
1696    if test "x$HAVE_SIGREG" = xt ; then
1697        echo "yes"
1698    else
1699        echo "no"
1700    fi
1701    rm -f genmake_t*
1702    
1703    printf "  Can we use stat() through C calls...  "
1704    check_HAVE_STAT
1705    if test "x$HAVE_STAT" != x ; then
1706        echo "yes"
1707    else
1708        echo "no"
1709  fi  fi
1710  rm -f genmake_t*  rm -f genmake_t*
1711    
1712  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we create NetCDF-enabled binaries...  "
1713  check_netcdf_libs  check_netcdf_libs
1714  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1715      echo "yes"      echo "yes"
1716  else  else
1717      echo "no"      echo "no"
1718  fi  fi
1719    DEFINES="$DEFINES $IGNORE_TIME"
1720    
1721    if test "x$EMBED_SRC" = xt ; then
1722        build_embed_encode
1723    fi
1724    if test "x$EMBED_SRC" = xt ; then
1725        ENABLE="$ENABLE embed_files"
1726    fi
1727    
1728    
1729  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1730  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1731  for d in $MODS ; do  for d in $MODS ; do
1732      if test ! -d $d ; then      if test ! -d $d ; then
1733          echo          echo
1734          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1735          exit 1          exit 1
1736      else      else
1737          echo -n " $d"          printf " $d"
1738          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1739          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1740      fi      fi
1741  done  done
1742  echo  echo
1743    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1744  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1745      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1746  fi  fi
1747    
1748  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1749      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1750        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1751          EXEDIR=../exe          EXEDIR=../exe
1752      else      else
1753          EXEDIR=.          EXEDIR=.
# Line 998  if test ! -d ${TOOLSDIR} ; then Line 1766  if test ! -d ${TOOLSDIR} ; then
1766      exit 1      exit 1
1767  fi  fi
1768  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1769      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1770        RETVAL=$?
1771        if test "x${RETVAL}" = x0 ; then
1772            S64='$(TOOLSDIR)/set64bitConst.sh'
1773        else
1774            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1775            RETVAL=$?
1776            if test "x${RETVAL}" = x0 ; then
1777                S64='$(TOOLSDIR)/set64bitConst.csh'
1778            else
1779                cat <<EOF
1780    
1781    ERROR: neither of the two default scripts:
1782    
1783        ${TOOLSDIR}/set64bitConst.sh
1784        ${TOOLSDIR}/set64bitConst.csh
1785    
1786      are working so please check paths or specify (with \$S64) a
1787      working version of this script.
1788    
1789    EOF
1790                exit 1
1791            fi
1792        fi
1793  fi  fi
1794  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1795    
# Line 1089  else Line 1880  else
1880          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1881          RETVAL=$?          RETVAL=$?
1882          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1883              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1884              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1885              exit 1              exit 1
1886          fi          fi
# Line 1097  else Line 1888  else
1888              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1889          done          done
1890          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1891          expand_pkg_groups          RET=1
1892            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1893          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1894      fi      fi
1895  fi  fi
1896    
1897  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1898    for i in $PACKAGES ; do
1899        echo $i >> ./.tmp_pack
1900    done
1901    for i in `grep  "-" ./.tmp_pack` ; do
1902        j=`echo $i | sed 's/[-]//'`
1903        DISABLE="$DISABLE $j"
1904    done
1905  pack=  pack=
1906  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1907      addit="t"      addit="t"
# Line 1119  PACKAGES="$pack" Line 1918  PACKAGES="$pack"
1918  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1919  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1920  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1921    # Test if each explicitly referenced package exists
1922  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1923      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1924        if test ! -d "$ROOTDIR/pkg/$j" ; then
1925          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1926          exit 1          exit 1
1927      fi      fi
1928      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1929  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1930  PACKAGES=  PACKAGES=
1931  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1932      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1933  done  done
1934    rm -f ./.tmp_pack
1935  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1936    
1937    #  Check availability of NetCDF and then either build the MNC template
1938    #  files or delete mnc from the list of available packages.
1939    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1940    RETVAL=$?
1941    if test "x$RETVAL" = x0 ; then
1942        if test "x$HAVE_NETCDF" != xt ; then
1943            cat <<EOF
1944    
1945    *********************************************************************
1946    WARNING: the "mnc" package was enabled but tests failed to compile
1947      NetCDF applications.  Please check that:
1948    
1949      1) NetCDF is correctly installed for this compiler and
1950      2) the LIBS variable (within the "optfile") specifies the correct
1951           NetCDF library to link against.
1952    
1953      Due to this failure, the "mnc" package is now DISABLED.
1954    *********************************************************************
1955    
1956    EOF
1957            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1958            DISABLE="$DISABLE mnc"
1959        else
1960            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1961            RETVAL=$?
1962            if test "x${RETVAL}" = x0 ; then
1963                rm -f make_mnc.errors
1964            else
1965                echo "Error: problem encountered while building source files in pkg/mnc:"
1966                cat make_mnc.errors 1>&2
1967                exit 1
1968            fi
1969        fi
1970    fi
1971    
1972  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1973  ck=  ck=
1974  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 1198  while test "x$ck" != xtt ; do Line 2033  while test "x$ck" != xtt ; do
2033              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
2034              exit 1              exit 1
2035          fi          fi
2036          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
2037            #i=$(( $i + 1 ))
2038      done      done
2039      ck=$ck"t"      ck=$ck"t"
2040  done  done
# Line 1217  for i in $PACKAGES ; do Line 2053  for i in $PACKAGES ; do
2053      fi      fi
2054  done  done
2055    
 #  Build MNC templates and check for ability to build and use NetCDF  
 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" = x0 ; then  
     ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         rm -f make_mnc.errors  
     else  
         echo "Error: problem encountered while building source files in pkg/mnc:"  
         cat make_mnc.errors 1>&2  
         exit 1  
     fi  
     if test "x$HAVE_NETCDF" != xt ; then  
         cat <<EOF  
   
 WARNING: the "mnc" package has been enabled but tests failed to  
   compile and/or execute NetCDF applications.  Please check that:  
   
   1) NetCDF is installed for your compiler and  
   2) the LIBS variable (within the 'optfile") specifies the correct  
        NetCDF library to link against.  
     
 EOF  
     fi  
 fi  
   
2056  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
2057  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
2058  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1263  for n in $names ; do Line 2072  for n in $names ; do
2072              fi              fi
2073          done          done
2074          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
2075              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2076              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2077          fi          fi
2078      fi      fi
2079  done  done
2080  ENABLED_PACKAGES=  ENABLED_PACKAGES=
2081  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2082      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2083      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2084  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
2085    
# Line 1354  for i in $SOURCEDIRS ; do Line 2163  for i in $SOURCEDIRS ; do
2163          cat $i/$j >> ad_files          cat $i/$j >> ad_files
2164      done      done
2165  done  done
2166    if test ! "x"$FS = "x.f" ; then
2167        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2168        mv -f ad_files_f ad_files
2169    fi
2170    
2171  echo  echo
2172  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
2173  echo "  setting INCLUDES"  echo "  setting INCLUDES"
2174  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
2175      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
2176          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
2177      fi      fi
2178  done  done
2179    
2180    if test ! "x$DIVA" = x ; then
2181        echo "  Creating the pseudo-MPI include directory"
2182        INCLUDES="-I./mpi_headers $INCLUDES"
2183        rm -rf ./mpi_headers
2184        mkdir -p ./mpi_headers
2185    
2186        if test "x$MPIINCLUDEDIR" = x ; then
2187            if test "x$MPIHOME" = x ; then
2188                MPIHOME='/usr'
2189            fi
2190            MPIINCLUDEDIR='$MPIHOME/include'
2191        fi
2192        
2193        if test -r $MPIINCLUDEDIR/mpif.h ; then
2194            for i in $MPI_HEADER_FILES; do
2195                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2196            done
2197    
2198            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2199        else
2200            echo " We cannot create a copy of mpif.h!"
2201            exit -1
2202        fi
2203    fi
2204    
2205  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2206  rm -rf .links.tmp  rm -rf .links.tmp
2207  mkdir .links.tmp  mkdir .links.tmp
2208    touch .links.tmp/foo
2209    if test ! -r ".links.tmp/foo" ; then
2210        echo
2211        echo "ERROR : something is wrong with your directory permissions or"
2212        echo "   your user file-creation mask (\"umask\") since creating a"
2213        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2214        echo "   not working.  Please try setting your umask to something"
2215        echo "   sane such as:"
2216        echo
2217        echo "      umask 0002"
2218        echo
2219        echo "   and please verify that you have the proper permissions for"
2220        echo "   creating sub-directories and then reading files created"
2221        echo "   within them."
2222        echo
2223        exit 1
2224    fi
2225    rm -f .links.tmp/foo
2226  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2227  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2228  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
2229  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
2230  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
2231  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
2232  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
2233  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2234  for d in $alldirs ; do  for d in $alldirs ; do
2235      deplist=      deplist=
# Line 1385  for d in $alldirs ; do Line 2238  for d in $alldirs ; do
2238      for sf in $sfiles ; do      for sf in $sfiles ; do
2239          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2240              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2241                    ignore_f=f
2242                  case $d/$sf in                  case $d/$sf in
2243                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2244                            ignore_f=t
2245                          ;;                          ;;
2246                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2247                            ignore_f=t
2248                          ;;                          ;;
2249                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2250                            ignore_f=t
2251                          ;;                          ;;
2252                    *)                    ./BUILD_INFO.h)
2253                          touch .links.tmp/$sf                          ignore_f=t
                         deplist="$deplist $sf"  
                         ;;  
                 esac  
                 extn=`echo $sf | $AWK -F '.' '{print $NF}'`  
                 case $extn in  
                     F)  
                         echo    " \\"  >> srclist.inc  
                         echo -n " $sf" >> srclist.inc  
                         ;;  
                     F90)  
                         echo    " \\"  >> f90srclist.inc  
                         echo -n " $sf" >> f90srclist.inc  
                         ;;  
                     c)  
                         echo    " \\"  >> csrclist.inc  
                         echo -n " $sf" >> csrclist.inc  
2254                          ;;                          ;;
2255                      h)                    ./EMBEDDED_FILES.h)
2256                          echo    " \\"  >> hlist.inc                          ignore_f=t
                         echo -n " $sf" >> hlist.inc  
2257                          ;;                          ;;
2258                      flow)                    *)
2259                          echo    " \\"  >> ad_flow_files.inc                          #  For the local directory *ONLY*,
2260                          echo -n " $sf" >> ad_flow_files.inc                          #  ignore all soft-links
2261                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2262                                ignore_f=t
2263                            else
2264                                touch .links.tmp/$sf
2265                                deplist="$deplist $sf"
2266                            fi
2267                          ;;                          ;;
2268                  esac                  esac
2269                    if test "x$ignore_f" = xf ; then
2270                        extn=`echo $sf | $AWK -F. '{print $NF}'`
2271                        case $extn in
2272                            F)
2273                                echo    " \\"  >> srclist.inc
2274                                printf " $sf" >> srclist.inc
2275                                ;;
2276                            F90)
2277                                echo    " \\"  >> f90srclist.inc
2278                                printf " $sf" >> f90srclist.inc
2279                                ;;
2280                            c)
2281                                echo    " \\"  >> csrclist.inc
2282                                printf " $sf" >> csrclist.inc
2283                                ;;
2284                            h)
2285                                echo    " \\"  >> hlist.inc
2286                                printf " $sf" >> hlist.inc
2287                                ;;
2288                            flow)
2289                                echo    " \\"  >> ad_flow_files.inc
2290                                printf " $sf" >> ad_flow_files.inc
2291                                ;;
2292                        esac
2293                    fi
2294              fi              fi
2295          fi          fi
2296      done      done
# Line 1437  echo "" >> f90srclist.inc Line 2308  echo "" >> f90srclist.inc
2308  echo "" >> hlist.inc  echo "" >> hlist.inc
2309  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
2310    
2311  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
2312      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
2313  fi  fi
2314  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1446  echo "#    $MACHINE" >> $MAKEFILE Line 2317  echo "#    $MACHINE" >> $MAKEFILE
2317  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
2318  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
2319  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
2320  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
2321  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
2322  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2323    
2324  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
2325  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
# Line 1494  ENABLED_PACKAGES = ${ENABLED_PACKAGES} Line 2365  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2365  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2366    
2367  # These files are created by Makefile  # These files are created by Makefile
2368  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2369  EOF  EOF
2370    
2371  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2372        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2373    else
2374        echo "EMBEDDED_FILES = " >>$MAKEFILE
2375    fi
2376    
2377    #  Note: figure out some way to add Hyades JAM libraries here
2378  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2379  # Unix ln (link)  # Unix ln (link)
2380  LN = ${LN}  LN = ${LN}
# Line 1513  KPP = ${KPP} Line 2388  KPP = ${KPP}
2388  FC = ${FC}  FC = ${FC}
2389  # Fortran compiler  # Fortran compiler
2390  F90C = ${F90C}  F90C = ${F90C}
2391    # C compiler
2392    CC = ${CC}
2393  # Link editor  # Link editor
2394  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
2395    
2396  # Defines for CPP  # Defines for CPP
2397  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1535  CFLAGS = ${CFLAGS} Line 2412  CFLAGS = ${CFLAGS}
2412  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
2413  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
2414  # Flags and libraries needed for linking  # Flags and libraries needed for linking
2415  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2416  # Name of the Mekfile  # Name of the Mekfile
2417  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2418    
# Line 1546  cat csrclist.inc      >> $MAKEFILE Line 2423  cat csrclist.inc      >> $MAKEFILE
2423  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
2424  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
2425  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2426  echo               >> $MAKEFILE  echo >> $MAKEFILE
2427  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2428  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2429  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2430    echo >> $MAKEFILE
2431    echo '.SUFFIXES:' >> $MAKEFILE
2432    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2433  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2434  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2435    
2436  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2437    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2438  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2439  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2440          @echo Creating \$@ ...          @echo Creating \$@ ...
2441          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2442  depend:  depend:
2443          @make links          @make links
2444          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2445          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2446            -rm -f makedepend.out
2447    
2448    lib: libmitgcmuv.a
2449    
2450    libmitgcmuv.a: \$(OBJFILES)
2451            ar rcv libmitgcmuv.a \$(OBJFILES)
2452    
2453  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2454    
# Line 1577  output.txt: \$(EXECUTABLE) Line 2459  output.txt: \$(EXECUTABLE)
2459          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2460    
2461  clean:  clean:
2462          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2463  Clean:  Clean:
2464          @make clean          @make clean
2465          @make cleanlinks          @make cleanlinks
# Line 1588  CLEAN: Line 2470  CLEAN:
2470          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2471          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2472          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2473          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) *.txt STD* *diagnostics.log datetime
2474            -rm -rf mnc_test_*
2475    
2476  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2477  makefile:  makefile:
2478          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
2479  cleanlinks:  cleanlinks:
2480          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2481    
2482  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are create by make
2483  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2484          @echo Creating \$@ ...          @echo Creating \$@ ...
2485          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2486  AD_CONFIG.h:  AD_CONFIG.h:
2487          @echo Creating \$@ ...          @echo Creating \$@ ...
2488          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2489  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
2490          @echo Creating \$@ ...          @echo Creating \$@ ...
2491          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
2492    
2493  # The normal chain of rules is (  .F - .f - .o  )  BUILD_INFO.h:
2494  .F.f:          @echo Creating \$@ ...
2495    EOF
2496    
2497    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2498    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2499    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2500    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2501    
2502    if test "x$EMBED_SRC" = xt ; then
2503        cat >>$MAKEFILE <<EOF
2504    
2505    decode_files.o : EMBEDDED_FILES.h
2506    
2507    ##  \$(F77FILES)
2508    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2509            @echo Creating \$@ ...
2510            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2511            -rm -f all_fF.tar.gz
2512            -gzip all_fF.tar
2513    
2514    EMBEDDED_FILES.h : all_fF.tar.gz
2515            @echo Creating \$@ ...
2516            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2517    
2518    EOF
2519    fi
2520    
2521    cat >>$MAKEFILE <<EOF
2522    
2523    # The normal chain of rules is (  .F - .$FS - .o  )
2524    
2525    ## This nullifies any default implicit rules concerning these two file types:
2526    ## %.o : %.F
2527    
2528    .F.$FS:
2529          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2530  .f.o:  .$FS.o:
2531          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2532  .F90.f90:  .F90.$FS90:
2533          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2534  .f90.o:  .$FS90.o:
2535          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2536  .c.o:  .c.o:
2537          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2538    
2539  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2540  .F.p:  .F.p:
2541          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2542  .p.f:  .p.$FS:
2543          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2544    
2545  #=========================================  #=========================================
# Line 1649  done Line 2566  done
2566    
2567  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2568  echo >> $MAKEFILE  echo >> $MAKEFILE
2569  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2570  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2571  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2572      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2573      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2574  done  done
2575  echo >> $MAKEFILE  echo >> $MAKEFILE
2576  rm -f ad_files  rm -f ad_files
# Line 1662  cat >>$MAKEFILE <<EOF Line 2579  cat >>$MAKEFILE <<EOF
2579    
2580  # ... AD ...  # ... AD ...
2581  adall: ad_taf  adall: ad_taf
2582  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2583  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2584    
2585  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2586          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2587          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2588          -rm -f ad_config.template          -rm -f ad_config.template
2589          @make \$(F77FILES)          @make \$(F77FILES)
2590          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2591          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2592    
2593  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2594          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2595          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2596    
2597  adtafonly:  adtafonly:
2598          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2599          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2600    
2601  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
2602          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2603    
2604  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2605          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2606          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2607    
2608  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2609          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2610    
2611    adonlyfwd:
2612            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2613    
2614    adtrick:
2615            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2616    
2617  # ... FTL ...  # ... FTL ...
2618  ftlall: ftl_taf  ftlall: ftl_taf
2619  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2620  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2621    
2622  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2623          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2624          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2625          -rm -f ftl_config.template          -rm -f ftl_config.template
2626          @make \$(F77FILES)          @make \$(F77FILES)
2627          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2628          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2629    
2630  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2631          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2632          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2633    
2634  ftltafonly:  ftltafonly:
2635          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2636          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2637    
2638  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2639          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2640    
2641  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2642          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2643          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2644    
2645  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2646          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2647    
2648    
2649  # ... SVD ...  # ... SVD ...
2650  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2651  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2652            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2653    svdall: svd_touch svd_taf
2654    
2655  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2656          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2657    
2658            @echo "--->>> Only COMPILE svd code! <<<---"
2659            @echo "--->>> Assumes you previously <<<---"
2660            @echo "--->>> did make svdtaf        <<<---"
2661    
2662    svd_touch:
2663            @echo "--->>> Only COMPILE svd code! <<<---"
2664            @echo "--->>> Assumes you previously <<<---"
2665            @echo "--->>> did make svdtaf        <<<---"
2666            touch ad_taf_output.$FS ftl_taf_output.$FS
2667            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2668            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2669            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2670            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2671            -rm -f ftl_config.template
2672    
2673  #=========================================  #=========================================
2674    
# Line 1747  for i in $KPPFILES ; do Line 2685  for i in $KPPFILES ; do
2685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2686          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2687      fi      fi
2688      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2689  done  done
2690    
2691  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1757  for i in $NOOPTFILES ; do Line 2695  for i in $NOOPTFILES ; do
2695      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2696          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2697      fi      fi
2698      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2699      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2700  done  done
2701    
# Line 1771  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2709  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2709  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2710    
2711  # Create special header files  # Create special header files
2712  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2713  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2714      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2715  else  else
# Line 1785  else Line 2723  else
2723      fi      fi
2724  fi  fi
2725  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2726      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2727  fi  fi
2728    
2729    
2730  #  Write the "state" for future records  #  Write the "state" for future records
2731  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2732      echo -n "" > genmake_state      printf "" > genmake_state
2733      for i in $gm_state ; do      for i in $gm_state ; do
2734          t1="t2=\$$i"          t1="t2=\$$i"
2735          eval $t1          eval $t1

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.150

  ViewVC Help
Powered by ViewVC 1.1.22